/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the apigateway-2015-07-09.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.APIGateway.Model
{
    /// <summary>
    /// Quotas configured for a usage plan.
    /// </summary>
    public partial class QuotaSettings
    {
        private int? _limit;
        private int? _offset;
        private QuotaPeriodType _period;

        /// <summary>
        /// Gets and sets the property Limit. 
        /// <para>
        /// The maximum number of requests that can be made in a given time period.
        /// </para>
        /// </summary>
        public int Limit
        {
            get { return this._limit.GetValueOrDefault(); }
            set { this._limit = value; }
        }

        // Check to see if Limit property is set
        internal bool IsSetLimit()
        {
            return this._limit.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property Offset. 
        /// <para>
        /// The day that a time period starts. For example, with a time period of <code>WEEK</code>,
        /// an offset of <code>0</code> starts on Sunday, and an offset of <code>1</code> starts
        /// on Monday.
        /// </para>
        /// </summary>
        public int Offset
        {
            get { return this._offset.GetValueOrDefault(); }
            set { this._offset = value; }
        }

        // Check to see if Offset property is set
        internal bool IsSetOffset()
        {
            return this._offset.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property Period. 
        /// <para>
        /// The time period in which the limit applies. Valid values are "DAY", "WEEK" or "MONTH".
        /// </para>
        /// </summary>
        public QuotaPeriodType Period
        {
            get { return this._period; }
            set { this._period = value; }
        }

        // Check to see if Period property is set
        internal bool IsSetPeriod()
        {
            return this._period != null;
        }

    }
}