/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the alexaforbusiness-2017-11-09.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.AlexaForBusiness.Model
{
    /// <summary>
    /// This is the response object from the ListDeviceEvents operation.
    /// </summary>
    public partial class ListDeviceEventsResponse : AmazonWebServiceResponse
    {
        private List<DeviceEvent> _deviceEvents = new List<DeviceEvent>();
        private string _nextToken;

        /// <summary>
        /// Gets and sets the property DeviceEvents. 
        /// <para>
        /// The device events requested for the device ARN.
        /// </para>
        /// </summary>
        public List<DeviceEvent> DeviceEvents
        {
            get { return this._deviceEvents; }
            set { this._deviceEvents = value; }
        }

        // Check to see if DeviceEvents property is set
        internal bool IsSetDeviceEvents()
        {
            return this._deviceEvents != null && this._deviceEvents.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// The token returned to indicate that there is more data available.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=1100)]
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

    }
}