/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the appconfig-2019-10-09.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.AppConfig.Model
{
    /// <summary>
    /// Container for the parameters to the GetDeploymentStrategy operation.
    /// Retrieve information about a deployment strategy. A deployment strategy defines important
    /// criteria for rolling out your configuration to the designated targets. A deployment
    /// strategy includes: the overall duration required, a percentage of targets to receive
    /// the deployment during each interval, an algorithm that defines how percentage grows,
    /// and bake time.
    /// </summary>
    public partial class GetDeploymentStrategyRequest : AmazonAppConfigRequest
    {
        private string _deploymentStrategyId;

        /// <summary>
        /// Gets and sets the property DeploymentStrategyId. 
        /// <para>
        /// The ID of the deployment strategy to get.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public string DeploymentStrategyId
        {
            get { return this._deploymentStrategyId; }
            set { this._deploymentStrategyId = value; }
        }

        // Check to see if DeploymentStrategyId property is set
        internal bool IsSetDeploymentStrategyId()
        {
            return this._deploymentStrategyId != null;
        }

    }
}