/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the application-insights-2018-11-25.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.ApplicationInsights.Model
{
    /// <summary>
    /// Container for the parameters to the DescribeProblem operation.
    /// Describes an application problem.
    /// </summary>
    public partial class DescribeProblemRequest : AmazonApplicationInsightsRequest
    {
        private string _problemId;

        /// <summary>
        /// Gets and sets the property ProblemId. 
        /// <para>
        /// The ID of the problem.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true, Min=38, Max=38)]
        public string ProblemId
        {
            get { return this._problemId; }
            set { this._problemId = value; }
        }

        // Check to see if ProblemId property is set
        internal bool IsSetProblemId()
        {
            return this._problemId != null;
        }

    }
}