/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the athena-2017-05-18.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Athena.Model
{
    /// <summary>
    /// This is the response object from the ListTableMetadata operation.
    /// </summary>
    public partial class ListTableMetadataResponse : AmazonWebServiceResponse
    {
        private string _nextToken;
        private List<TableMetadata> _tableMetadataList = new List<TableMetadata>();

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// A token generated by the Athena service that specifies where to continue pagination
        /// if a previous request was truncated. To obtain the next set of pages, pass in the
        /// NextToken from the response object of the previous page call.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=1024)]
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

        /// <summary>
        /// Gets and sets the property TableMetadataList. 
        /// <para>
        /// A list of table metadata.
        /// </para>
        /// </summary>
        public List<TableMetadata> TableMetadataList
        {
            get { return this._tableMetadataList; }
            set { this._tableMetadataList = value; }
        }

        // Check to see if TableMetadataList property is set
        internal bool IsSetTableMetadataList()
        {
            return this._tableMetadataList != null && this._tableMetadataList.Count > 0; 
        }

    }
}