/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the batch-2016-08-10.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.Batch.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.Batch.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for LinuxParameters Object
    /// </summary>  
    public class LinuxParametersUnmarshaller : IUnmarshaller<LinuxParameters, XmlUnmarshallerContext>, IUnmarshaller<LinuxParameters, JsonUnmarshallerContext>
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        LinuxParameters IUnmarshaller<LinuxParameters, XmlUnmarshallerContext>.Unmarshall(XmlUnmarshallerContext context)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public LinuxParameters Unmarshall(JsonUnmarshallerContext context)
        {
            context.Read();
            if (context.CurrentTokenType == JsonToken.Null) 
                return null;

            LinuxParameters unmarshalledObject = new LinuxParameters();
        
            int targetDepth = context.CurrentDepth;
            while (context.ReadAtDepth(targetDepth))
            {
                if (context.TestExpression("devices", targetDepth))
                {
                    var unmarshaller = new ListUnmarshaller<Device, DeviceUnmarshaller>(DeviceUnmarshaller.Instance);
                    unmarshalledObject.Devices = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("initProcessEnabled", targetDepth))
                {
                    var unmarshaller = BoolUnmarshaller.Instance;
                    unmarshalledObject.InitProcessEnabled = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("maxSwap", targetDepth))
                {
                    var unmarshaller = IntUnmarshaller.Instance;
                    unmarshalledObject.MaxSwap = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("sharedMemorySize", targetDepth))
                {
                    var unmarshaller = IntUnmarshaller.Instance;
                    unmarshalledObject.SharedMemorySize = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("swappiness", targetDepth))
                {
                    var unmarshaller = IntUnmarshaller.Instance;
                    unmarshalledObject.Swappiness = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("tmpfs", targetDepth))
                {
                    var unmarshaller = new ListUnmarshaller<Tmpfs, TmpfsUnmarshaller>(TmpfsUnmarshaller.Instance);
                    unmarshalledObject.Tmpfs = unmarshaller.Unmarshall(context);
                    continue;
                }
            }
          
            return unmarshalledObject;
        }


        private static LinuxParametersUnmarshaller _instance = new LinuxParametersUnmarshaller();        

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static LinuxParametersUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}