/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the chime-2018-05-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Chime.Model
{
    /// <summary>
    /// Container for the parameters to the DeleteVoiceConnectorTerminationCredentials operation.
    /// Deletes the specified SIP credentials used by your equipment to authenticate during
    /// call termination.
    /// </summary>
    public partial class DeleteVoiceConnectorTerminationCredentialsRequest : AmazonChimeRequest
    {
        private List<string> _usernames = new List<string>();
        private string _voiceConnectorId;

        /// <summary>
        /// Gets and sets the property Usernames. 
        /// <para>
        /// The RFC2617 compliant username associated with the SIP credentials, in US-ASCII format.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public List<string> Usernames
        {
            get { return this._usernames; }
            set { this._usernames = value; }
        }

        // Check to see if Usernames property is set
        internal bool IsSetUsernames()
        {
            return this._usernames != null && this._usernames.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property VoiceConnectorId. 
        /// <para>
        /// The Amazon Chime Voice Connector ID.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public string VoiceConnectorId
        {
            get { return this._voiceConnectorId; }
            set { this._voiceConnectorId = value; }
        }

        // Check to see if VoiceConnectorId property is set
        internal bool IsSetVoiceConnectorId()
        {
            return this._voiceConnectorId != null;
        }

    }
}