/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the monitoring-2010-08-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.CloudWatch.Model
{
    /// <summary>
    /// Container for the parameters to the StopMetricStreams operation.
    /// Stops the streaming of metrics for one or more of your metric streams.
    /// </summary>
    public partial class StopMetricStreamsRequest : AmazonCloudWatchRequest
    {
        private List<string> _names = new List<string>();

        /// <summary>
        /// Gets and sets the property Names. 
        /// <para>
        /// The array of the names of metric streams to stop streaming.
        /// </para>
        ///  
        /// <para>
        /// This is an "all or nothing" operation. If you do not have permission to access all
        /// of the metric streams that you list here, then none of the streams that you list in
        /// the operation will stop streaming.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public List<string> Names
        {
            get { return this._names; }
            set { this._names = value; }
        }

        // Check to see if Names property is set
        internal bool IsSetNames()
        {
            return this._names != null && this._names.Count > 0; 
        }

    }
}