/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the codeartifact-2018-09-22.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.CodeArtifact.Model
{
    /// <summary>
    /// Contains the revision and status of a package version.
    /// </summary>
    public partial class SuccessfulPackageVersionInfo
    {
        private string _revision;
        private PackageVersionStatus _status;

        /// <summary>
        /// Gets and sets the property Revision. 
        /// <para>
        ///  The revision of a package version. 
        /// </para>
        /// </summary>
        public string Revision
        {
            get { return this._revision; }
            set { this._revision = value; }
        }

        // Check to see if Revision property is set
        internal bool IsSetRevision()
        {
            return this._revision != null;
        }

        /// <summary>
        /// Gets and sets the property Status. 
        /// <para>
        ///  The status of a package version. Valid statuses are: 
        /// </para>
        ///  <ul> <li> 
        /// <para>
        ///  <code>Published</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>Unfinished</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>Unlisted</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>Archived</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>Disposed</code> 
        /// </para>
        ///  </li> </ul>
        /// </summary>
        public PackageVersionStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }

        // Check to see if Status property is set
        internal bool IsSetStatus()
        {
            return this._status != null;
        }

    }
}