/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the cognito-identity-2014-06-30.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.CognitoIdentity.Model
{
    /// <summary>
    /// A container for rules.
    /// </summary>
    public partial class RulesConfigurationType
    {
        private List<MappingRule> _rules = new List<MappingRule>();

        /// <summary>
        /// Gets and sets the property Rules. 
        /// <para>
        /// An array of rules. You can specify up to 25 rules per identity provider.
        /// </para>
        ///  
        /// <para>
        /// Rules are evaluated in order. The first one to match specifies the role.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true, Min=1, Max=400)]
        public List<MappingRule> Rules
        {
            get { return this._rules; }
            set { this._rules = value; }
        }

        // Check to see if Rules property is set
        internal bool IsSetRules()
        {
            return this._rules != null && this._rules.Count > 0; 
        }

    }
}