/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ce-2017-10-25.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.CostExplorer.Model
{
    /// <summary>
    /// A group of reservations that share a set of attributes.
    /// </summary>
    public partial class ReservationCoverageGroup
    {
        private Dictionary<string, string> _attributes = new Dictionary<string, string>();
        private Coverage _coverage;

        /// <summary>
        /// Gets and sets the property Attributes. 
        /// <para>
        /// The attributes for this group of reservations.
        /// </para>
        /// </summary>
        public Dictionary<string, string> Attributes
        {
            get { return this._attributes; }
            set { this._attributes = value; }
        }

        // Check to see if Attributes property is set
        internal bool IsSetAttributes()
        {
            return this._attributes != null && this._attributes.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property Coverage. 
        /// <para>
        /// How much instance usage this group of reservations covered.
        /// </para>
        /// </summary>
        public Coverage Coverage
        {
            get { return this._coverage; }
            set { this._coverage = value; }
        }

        // Check to see if Coverage property is set
        internal bool IsSetCoverage()
        {
            return this._coverage != null;
        }

    }
}