/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the dataexchange-2017-07-25.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.DataExchange.Model
{
    /// <summary>
    /// An error that occurred with the job request.
    /// </summary>
    public partial class JobError
    {
        private Code _code;
        private Details _details;
        private JobErrorLimitName _limitName;
        private double? _limitValue;
        private string _message;
        private string _resourceId;
        private JobErrorResourceTypes _resourceType;

        /// <summary>
        /// Gets and sets the property Code. The code for the job error.
        /// </summary>
        [AWSProperty(Required=true)]
        public Code Code
        {
            get { return this._code; }
            set { this._code = value; }
        }

        // Check to see if Code property is set
        internal bool IsSetCode()
        {
            return this._code != null;
        }

        /// <summary>
        /// Gets and sets the property Details.
        /// </summary>
        public Details Details
        {
            get { return this._details; }
            set { this._details = value; }
        }

        // Check to see if Details property is set
        internal bool IsSetDetails()
        {
            return this._details != null;
        }

        /// <summary>
        /// Gets and sets the property LimitName. 
        /// <para>
        /// The name of the limit that was reached.
        /// </para>
        /// </summary>
        public JobErrorLimitName LimitName
        {
            get { return this._limitName; }
            set { this._limitName = value; }
        }

        // Check to see if LimitName property is set
        internal bool IsSetLimitName()
        {
            return this._limitName != null;
        }

        /// <summary>
        /// Gets and sets the property LimitValue. The value of the exceeded limit.
        /// </summary>
        public double LimitValue
        {
            get { return this._limitValue.GetValueOrDefault(); }
            set { this._limitValue = value; }
        }

        // Check to see if LimitValue property is set
        internal bool IsSetLimitValue()
        {
            return this._limitValue.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property Message. The message related to the job error.
        /// </summary>
        [AWSProperty(Required=true)]
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }

        // Check to see if Message property is set
        internal bool IsSetMessage()
        {
            return this._message != null;
        }

        /// <summary>
        /// Gets and sets the property ResourceId. The unique identifier for the resource related
        /// to the error.
        /// </summary>
        public string ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }

        // Check to see if ResourceId property is set
        internal bool IsSetResourceId()
        {
            return this._resourceId != null;
        }

        /// <summary>
        /// Gets and sets the property ResourceType. The type of resource related to the error.
        /// </summary>
        public JobErrorResourceTypes ResourceType
        {
            get { return this._resourceType; }
            set { this._resourceType = value; }
        }

        // Check to see if ResourceType property is set
        internal bool IsSetResourceType()
        {
            return this._resourceType != null;
        }

    }
}