/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the dms-2016-01-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.DatabaseMigrationService.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.DatabaseMigrationService.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for TableStatistics Object
    /// </summary>  
    public class TableStatisticsUnmarshaller : IUnmarshaller<TableStatistics, XmlUnmarshallerContext>, IUnmarshaller<TableStatistics, JsonUnmarshallerContext>
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        TableStatistics IUnmarshaller<TableStatistics, XmlUnmarshallerContext>.Unmarshall(XmlUnmarshallerContext context)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public TableStatistics Unmarshall(JsonUnmarshallerContext context)
        {
            context.Read();
            if (context.CurrentTokenType == JsonToken.Null) 
                return null;

            TableStatistics unmarshalledObject = new TableStatistics();
        
            int targetDepth = context.CurrentDepth;
            while (context.ReadAtDepth(targetDepth))
            {
                if (context.TestExpression("Ddls", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.Ddls = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("Deletes", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.Deletes = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadCondtnlChkFailedRows", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.FullLoadCondtnlChkFailedRows = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadEndTime", targetDepth))
                {
                    var unmarshaller = DateTimeUnmarshaller.Instance;
                    unmarshalledObject.FullLoadEndTime = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadErrorRows", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.FullLoadErrorRows = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadReloaded", targetDepth))
                {
                    var unmarshaller = BoolUnmarshaller.Instance;
                    unmarshalledObject.FullLoadReloaded = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadRows", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.FullLoadRows = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("FullLoadStartTime", targetDepth))
                {
                    var unmarshaller = DateTimeUnmarshaller.Instance;
                    unmarshalledObject.FullLoadStartTime = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("Inserts", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.Inserts = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("LastUpdateTime", targetDepth))
                {
                    var unmarshaller = DateTimeUnmarshaller.Instance;
                    unmarshalledObject.LastUpdateTime = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("SchemaName", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.SchemaName = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("TableName", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.TableName = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("TableState", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.TableState = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("Updates", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.Updates = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("ValidationFailedRecords", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.ValidationFailedRecords = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("ValidationPendingRecords", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.ValidationPendingRecords = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("ValidationState", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.ValidationState = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("ValidationStateDetails", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.ValidationStateDetails = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("ValidationSuspendedRecords", targetDepth))
                {
                    var unmarshaller = LongUnmarshaller.Instance;
                    unmarshalledObject.ValidationSuspendedRecords = unmarshaller.Unmarshall(context);
                    continue;
                }
            }
          
            return unmarshalledObject;
        }


        private static TableStatisticsUnmarshaller _instance = new TableStatisticsUnmarshaller();        

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static TableStatisticsUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}