/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the devops-guru-2020-12-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.DevOpsGuru.Model
{
    /// <summary>
    /// Information about an event that is related to a recommendation.
    /// </summary>
    public partial class RecommendationRelatedEvent
    {
        private string _name;
        private List<RecommendationRelatedEventResource> _resources = new List<RecommendationRelatedEventResource>();

        /// <summary>
        /// Gets and sets the property Name. 
        /// <para>
        ///  The name of the event. This corresponds to the <code>Name</code> field in an <code>Event</code>
        /// object. 
        /// </para>
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        // Check to see if Name property is set
        internal bool IsSetName()
        {
            return this._name != null;
        }

        /// <summary>
        /// Gets and sets the property Resources. 
        /// <para>
        ///  A <code>ResourceCollection</code> object that contains arrays of the names of AWS
        /// CloudFormation stacks. You can specify up to 500 AWS CloudFormation stacks. 
        /// </para>
        /// </summary>
        public List<RecommendationRelatedEventResource> Resources
        {
            get { return this._resources; }
            set { this._resources = value; }
        }

        // Check to see if Resources property is set
        internal bool IsSetResources()
        {
            return this._resources != null && this._resources.Count > 0; 
        }

    }
}