/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ds-2015-04-16.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.DirectoryService.Model
{
    /// <summary>
    /// Represents a log subscription, which tracks real-time data from a chosen log group
    /// to a specified destination.
    /// </summary>
    public partial class LogSubscription
    {
        private string _directoryId;
        private string _logGroupName;
        private DateTime? _subscriptionCreatedDateTime;

        /// <summary>
        /// Gets and sets the property DirectoryId. 
        /// <para>
        /// Identifier (ID) of the directory that you want to associate with the log subscription.
        /// </para>
        /// </summary>
        public string DirectoryId
        {
            get { return this._directoryId; }
            set { this._directoryId = value; }
        }

        // Check to see if DirectoryId property is set
        internal bool IsSetDirectoryId()
        {
            return this._directoryId != null;
        }

        /// <summary>
        /// Gets and sets the property LogGroupName. 
        /// <para>
        /// The name of the log group.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=512)]
        public string LogGroupName
        {
            get { return this._logGroupName; }
            set { this._logGroupName = value; }
        }

        // Check to see if LogGroupName property is set
        internal bool IsSetLogGroupName()
        {
            return this._logGroupName != null;
        }

        /// <summary>
        /// Gets and sets the property SubscriptionCreatedDateTime. 
        /// <para>
        /// The date and time that the log subscription was created.
        /// </para>
        /// </summary>
        public DateTime SubscriptionCreatedDateTime
        {
            get { return this._subscriptionCreatedDateTime.GetValueOrDefault(); }
            set { this._subscriptionCreatedDateTime = value; }
        }

        // Check to see if SubscriptionCreatedDateTime property is set
        internal bool IsSetSubscriptionCreatedDateTime()
        {
            return this._subscriptionCreatedDateTime.HasValue; 
        }

    }
}