/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the dynamodb-2012-08-10.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.DynamoDBv2.Model
{
    /// <summary>
    /// Represents the auto scaling policy to be modified.
    /// </summary>
    public partial class AutoScalingPolicyUpdate
    {
        private string _policyName;
        private AutoScalingTargetTrackingScalingPolicyConfigurationUpdate _targetTrackingScalingPolicyConfiguration;

        /// <summary>
        /// Gets and sets the property PolicyName. 
        /// <para>
        /// The name of the scaling policy.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=256)]
        public string PolicyName
        {
            get { return this._policyName; }
            set { this._policyName = value; }
        }

        // Check to see if PolicyName property is set
        internal bool IsSetPolicyName()
        {
            return this._policyName != null;
        }

        /// <summary>
        /// Gets and sets the property TargetTrackingScalingPolicyConfiguration. 
        /// <para>
        /// Represents a target tracking scaling policy configuration.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public AutoScalingTargetTrackingScalingPolicyConfigurationUpdate TargetTrackingScalingPolicyConfiguration
        {
            get { return this._targetTrackingScalingPolicyConfiguration; }
            set { this._targetTrackingScalingPolicyConfiguration = value; }
        }

        // Check to see if TargetTrackingScalingPolicyConfiguration property is set
        internal bool IsSetTargetTrackingScalingPolicyConfiguration()
        {
            return this._targetTrackingScalingPolicyConfiguration != null;
        }

    }
}