/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ec2-2016-11-15.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.EC2.Model
{
    /// <summary>
    /// The attributes associated with an Elastic IP address.
    /// </summary>
    public partial class AddressAttribute
    {
        private string _allocationId;
        private string _ptrRecord;
        private PtrUpdateStatus _ptrRecordUpdate;
        private string _publicIp;

        /// <summary>
        /// Gets and sets the property AllocationId. 
        /// <para>
        /// [EC2-VPC] The allocation ID.
        /// </para>
        /// </summary>
        public string AllocationId
        {
            get { return this._allocationId; }
            set { this._allocationId = value; }
        }

        // Check to see if AllocationId property is set
        internal bool IsSetAllocationId()
        {
            return this._allocationId != null;
        }

        /// <summary>
        /// Gets and sets the property PtrRecord. 
        /// <para>
        /// The pointer (PTR) record for the IP address.
        /// </para>
        /// </summary>
        public string PtrRecord
        {
            get { return this._ptrRecord; }
            set { this._ptrRecord = value; }
        }

        // Check to see if PtrRecord property is set
        internal bool IsSetPtrRecord()
        {
            return this._ptrRecord != null;
        }

        /// <summary>
        /// Gets and sets the property PtrRecordUpdate. 
        /// <para>
        /// The updated PTR record for the IP address.
        /// </para>
        /// </summary>
        public PtrUpdateStatus PtrRecordUpdate
        {
            get { return this._ptrRecordUpdate; }
            set { this._ptrRecordUpdate = value; }
        }

        // Check to see if PtrRecordUpdate property is set
        internal bool IsSetPtrRecordUpdate()
        {
            return this._ptrRecordUpdate != null;
        }

        /// <summary>
        /// Gets and sets the property PublicIp. 
        /// <para>
        /// The public IP address.
        /// </para>
        /// </summary>
        public string PublicIp
        {
            get { return this._publicIp; }
            set { this._publicIp = value; }
        }

        // Check to see if PublicIp property is set
        internal bool IsSetPublicIp()
        {
            return this._publicIp != null;
        }

    }
}