/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ec2-2016-11-15.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.EC2.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
namespace Amazon.EC2.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for StoreImageTaskResult Object
    /// </summary>  
    public class StoreImageTaskResultUnmarshaller : IUnmarshaller<StoreImageTaskResult, XmlUnmarshallerContext>, IUnmarshaller<StoreImageTaskResult, JsonUnmarshallerContext>
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public StoreImageTaskResult Unmarshall(XmlUnmarshallerContext context)
        {
            StoreImageTaskResult unmarshalledObject = new StoreImageTaskResult();
            int originalDepth = context.CurrentDepth;
            int targetDepth = originalDepth + 1;
            
            if (context.IsStartOfDocument) 
               targetDepth += 2;
            
            while (context.ReadAtDepth(originalDepth))
            {
                if (context.IsStartElement || context.IsAttribute)
                {
                    if (context.TestExpression("amiId", targetDepth))
                    {
                        var unmarshaller = StringUnmarshaller.Instance;
                        unmarshalledObject.AmiId = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("bucket", targetDepth))
                    {
                        var unmarshaller = StringUnmarshaller.Instance;
                        unmarshalledObject.Bucket = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("progressPercentage", targetDepth))
                    {
                        var unmarshaller = IntUnmarshaller.Instance;
                        unmarshalledObject.ProgressPercentage = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("s3objectKey", targetDepth))
                    {
                        var unmarshaller = StringUnmarshaller.Instance;
                        unmarshalledObject.S3objectKey = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("storeTaskFailureReason", targetDepth))
                    {
                        var unmarshaller = StringUnmarshaller.Instance;
                        unmarshalledObject.StoreTaskFailureReason = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("storeTaskState", targetDepth))
                    {
                        var unmarshaller = StringUnmarshaller.Instance;
                        unmarshalledObject.StoreTaskState = unmarshaller.Unmarshall(context);
                        continue;
                    }
                    if (context.TestExpression("taskStartTime", targetDepth))
                    {
                        var unmarshaller = DateTimeUnmarshaller.Instance;
                        unmarshalledObject.TaskStartTime = unmarshaller.Unmarshall(context);
                        continue;
                    }
                }
                else if (context.IsEndElement && context.CurrentDepth < originalDepth)
                {
                    return unmarshalledObject;
                }
            }

            return unmarshalledObject;
        }

        /// <summary>
        /// Unmarshaller error response to exception.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public StoreImageTaskResult Unmarshall(JsonUnmarshallerContext context)
        {
            return null;
        }


        private static StoreImageTaskResultUnmarshaller _instance = new StoreImageTaskResultUnmarshaller();        

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static StoreImageTaskResultUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}