/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the es-2015-01-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Elasticsearch.Model
{
    /// <summary>
    /// Container for the parameters to the DeleteElasticsearchServiceRole operation.
    /// Deletes the service-linked role that Elasticsearch Service uses to manage and maintain
    /// VPC domains. Role deletion will fail if any existing VPC domains use the role. You
    /// must delete any such Elasticsearch domains before deleting the role. See <a href="http://docs.aws.amazon.com/elasticsearch-service/latest/developerguide/es-vpc.html#es-enabling-slr"
    /// target="_blank">Deleting Elasticsearch Service Role</a> in <i>VPC Endpoints for Amazon
    /// Elasticsearch Service Domains</i>.
    /// </summary>
    public partial class DeleteElasticsearchServiceRoleRequest : AmazonElasticsearchRequest
    {

    }
}