/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the finspace-data-2020-07-13.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.FinSpaceData.Model
{
    /// <summary>
    /// This is the response object from the CreateChangeset operation.
    /// </summary>
    public partial class CreateChangesetResponse : AmazonWebServiceResponse
    {
        private ChangesetInfo _changeset;

        /// <summary>
        /// Gets and sets the property Changeset. 
        /// <para>
        /// Returns the changeset details.
        /// </para>
        /// </summary>
        public ChangesetInfo Changeset
        {
            get { return this._changeset; }
            set { this._changeset = value; }
        }

        // Check to see if Changeset property is set
        internal bool IsSetChangeset()
        {
            return this._changeset != null;
        }

    }
}