/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the gamelift-2015-10-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.GameLift.Model
{
    /// <summary>
    /// A fleet or alias designated in a game session queue. Queues fulfill requests for new
    /// game sessions by placing a new game session on any of the queue's destinations. 
    /// 
    ///  
    /// <para>
    /// Destinations are part of a <a>GameSessionQueue</a>.
    /// </para>
    /// </summary>
    public partial class GameSessionQueueDestination
    {
        private string _destinationArn;

        /// <summary>
        /// Gets and sets the property DestinationArn. 
        /// <para>
        /// The Amazon Resource Name (ARN) that is assigned to fleet or fleet alias. ARNs, which
        /// include a fleet ID or alias ID and a Region name, provide a unique identifier across
        /// all Regions. 
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=256)]
        public string DestinationArn
        {
            get { return this._destinationArn; }
            set { this._destinationArn = value; }
        }

        // Check to see if DestinationArn property is set
        internal bool IsSetDestinationArn()
        {
            return this._destinationArn != null;
        }

    }
}