/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the glue-2017-03-31.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Glue.Model
{
    /// <summary>
    /// This is the response object from the QuerySchemaVersionMetadata operation.
    /// </summary>
    public partial class QuerySchemaVersionMetadataResponse : AmazonWebServiceResponse
    {
        private Dictionary<string, MetadataInfo> _metadataInfoMap = new Dictionary<string, MetadataInfo>();
        private string _nextToken;
        private string _schemaVersionId;

        /// <summary>
        /// Gets and sets the property MetadataInfoMap. 
        /// <para>
        /// A map of a metadata key and associated values.
        /// </para>
        /// </summary>
        public Dictionary<string, MetadataInfo> MetadataInfoMap
        {
            get { return this._metadataInfoMap; }
            set { this._metadataInfoMap = value; }
        }

        // Check to see if MetadataInfoMap property is set
        internal bool IsSetMetadataInfoMap()
        {
            return this._metadataInfoMap != null && this._metadataInfoMap.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// A continuation token for paginating the returned list of tokens, returned if the current
        /// segment of the list is not the last.
        /// </para>
        /// </summary>
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

        /// <summary>
        /// Gets and sets the property SchemaVersionId. 
        /// <para>
        /// The unique version ID of the schema version.
        /// </para>
        /// </summary>
        [AWSProperty(Min=36, Max=36)]
        public string SchemaVersionId
        {
            get { return this._schemaVersionId; }
            set { this._schemaVersionId = value; }
        }

        // Check to see if SchemaVersionId property is set
        internal bool IsSetSchemaVersionId()
        {
            return this._schemaVersionId != null;
        }

    }
}