/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the databrew-2017-07-25.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.GlueDataBrew.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.GlueDataBrew.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// DatabaseInputDefinition Marshaller
    /// </summary>       
    public class DatabaseInputDefinitionMarshaller : IRequestMarshaller<DatabaseInputDefinition, JsonMarshallerContext> 
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="requestObject"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public void Marshall(DatabaseInputDefinition requestObject, JsonMarshallerContext context)
        {
            if(requestObject.IsSetDatabaseTableName())
            {
                context.Writer.WritePropertyName("DatabaseTableName");
                context.Writer.Write(requestObject.DatabaseTableName);
            }

            if(requestObject.IsSetGlueConnectionName())
            {
                context.Writer.WritePropertyName("GlueConnectionName");
                context.Writer.Write(requestObject.GlueConnectionName);
            }

            if(requestObject.IsSetTempDirectory())
            {
                context.Writer.WritePropertyName("TempDirectory");
                context.Writer.WriteObjectStart();

                var marshaller = S3LocationMarshaller.Instance;
                marshaller.Marshall(requestObject.TempDirectory, context);

                context.Writer.WriteObjectEnd();
            }

        }

        /// <summary>
        /// Singleton Marshaller.
        /// </summary>  
        public readonly static DatabaseInputDefinitionMarshaller Instance = new DatabaseInputDefinitionMarshaller();

    }
}