/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the iam-2010-05-08.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.IdentityManagement.Model
{
    /// <summary>
    /// An object that contains details about how a service-linked role is used, if that information
    /// is returned by the service.
    /// 
    ///  
    /// <para>
    /// This data type is used as a response element in the <a>GetServiceLinkedRoleDeletionStatus</a>
    /// operation.
    /// </para>
    /// </summary>
    public partial class RoleUsageType
    {
        private string _region;
        private List<string> _resources = new List<string>();

        /// <summary>
        /// Gets and sets the property Region. 
        /// <para>
        /// The name of the Region where the service-linked role is being used.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=100)]
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }

        // Check to see if Region property is set
        internal bool IsSetRegion()
        {
            return this._region != null;
        }

        /// <summary>
        /// Gets and sets the property Resources. 
        /// <para>
        /// The name of the resource that is using the service-linked role.
        /// </para>
        /// </summary>
        public List<string> Resources
        {
            get { return this._resources; }
            set { this._resources = value; }
        }

        // Check to see if Resources property is set
        internal bool IsSetResources()
        {
            return this._resources != null && this._resources.Count > 0; 
        }

    }
}