/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the imagebuilder-2019-12-02.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Imagebuilder.Model
{
    /// <summary>
    /// This is the response object from the ListComponentBuildVersions operation.
    /// </summary>
    public partial class ListComponentBuildVersionsResponse : AmazonWebServiceResponse
    {
        private List<ComponentSummary> _componentSummaryList = new List<ComponentSummary>();
        private string _nextToken;
        private string _requestId;

        /// <summary>
        /// Gets and sets the property ComponentSummaryList. 
        /// <para>
        /// The list of component summaries for the specified semantic version.
        /// </para>
        /// </summary>
        public List<ComponentSummary> ComponentSummaryList
        {
            get { return this._componentSummaryList; }
            set { this._componentSummaryList = value; }
        }

        // Check to see if ComponentSummaryList property is set
        internal bool IsSetComponentSummaryList()
        {
            return this._componentSummaryList != null && this._componentSummaryList.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// The next token used for paginated responses. When this is not empty, there are additional
        /// elements that the service has not included in this request. Use this token with the
        /// next request to retrieve additional objects.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=65535)]
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

        /// <summary>
        /// Gets and sets the property RequestId. 
        /// <para>
        /// The request ID that uniquely identifies this request.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=1024)]
        public string RequestId
        {
            get { return this._requestId; }
            set { this._requestId = value; }
        }

        // Check to see if RequestId property is set
        internal bool IsSetRequestId()
        {
            return this._requestId != null;
        }

    }
}