/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the iotsitewise-2019-12-02.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.IoTSiteWise.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.IoTSiteWise.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// GetAssetPropertyValue Request Marshaller
    /// </summary>       
    public class GetAssetPropertyValueRequestMarshaller : IMarshaller<IRequest, GetAssetPropertyValueRequest> , IMarshaller<IRequest,AmazonWebServiceRequest>
    {
        /// <summary>
        /// Marshaller the request object to the HTTP request.
        /// </summary>  
        /// <param name="input"></param>
        /// <returns></returns>
        public IRequest Marshall(AmazonWebServiceRequest input)
        {
            return this.Marshall((GetAssetPropertyValueRequest)input);
        }

        /// <summary>
        /// Marshaller the request object to the HTTP request.
        /// </summary>  
        /// <param name="publicRequest"></param>
        /// <returns></returns>
        public IRequest Marshall(GetAssetPropertyValueRequest publicRequest)
        {
            IRequest request = new DefaultRequest(publicRequest, "Amazon.IoTSiteWise");
            request.Headers[Amazon.Util.HeaderKeys.XAmzApiVersion] = "2019-12-02";            
            request.HttpMethod = "GET";

            
            if (publicRequest.IsSetAssetId())
                request.Parameters.Add("assetId", StringUtils.FromString(publicRequest.AssetId));
            
            if (publicRequest.IsSetPropertyAlias())
                request.Parameters.Add("propertyAlias", StringUtils.FromString(publicRequest.PropertyAlias));
            
            if (publicRequest.IsSetPropertyId())
                request.Parameters.Add("propertyId", StringUtils.FromString(publicRequest.PropertyId));
            request.ResourcePath = "/properties/latest";
            request.UseQueryString = true;
            
            request.HostPrefix = $"data.";

            return request;
        }
        private static GetAssetPropertyValueRequestMarshaller _instance = new GetAssetPropertyValueRequestMarshaller();        

        internal static GetAssetPropertyValueRequestMarshaller GetInstance()
        {
            return _instance;
        }

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static GetAssetPropertyValueRequestMarshaller Instance
        {
            get
            {
                return _instance;
            }
        }

    }
}