/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the kendra-2019-02-03.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.Kendra.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.Kendra.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// OneDriveUsers Marshaller
    /// </summary>       
    public class OneDriveUsersMarshaller : IRequestMarshaller<OneDriveUsers, JsonMarshallerContext> 
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="requestObject"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public void Marshall(OneDriveUsers requestObject, JsonMarshallerContext context)
        {
            if(requestObject.IsSetOneDriveUserList())
            {
                context.Writer.WritePropertyName("OneDriveUserList");
                context.Writer.WriteArrayStart();
                foreach(var requestObjectOneDriveUserListListValue in requestObject.OneDriveUserList)
                {
                        context.Writer.Write(requestObjectOneDriveUserListListValue);
                }
                context.Writer.WriteArrayEnd();
            }

            if(requestObject.IsSetOneDriveUserS3Path())
            {
                context.Writer.WritePropertyName("OneDriveUserS3Path");
                context.Writer.WriteObjectStart();

                var marshaller = S3PathMarshaller.Instance;
                marshaller.Marshall(requestObject.OneDriveUserS3Path, context);

                context.Writer.WriteObjectEnd();
            }

        }

        /// <summary>
        /// Singleton Marshaller.
        /// </summary>  
        public readonly static OneDriveUsersMarshaller Instance = new OneDriveUsersMarshaller();

    }
}