/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the kinesis-2013-12-02.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Kinesis.Model
{
    /// <summary>
    /// This is the response object from the RegisterStreamConsumer operation.
    /// </summary>
    public partial class RegisterStreamConsumerResponse : AmazonWebServiceResponse
    {
        private Consumer _consumer;

        /// <summary>
        /// Gets and sets the property Consumer. 
        /// <para>
        /// An object that represents the details of the consumer you registered. When you register
        /// a consumer, it gets an ARN that is generated by Kinesis Data Streams.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public Consumer Consumer
        {
            get { return this._consumer; }
            set { this._consumer = value; }
        }

        // Check to see if Consumer property is set
        internal bool IsSetConsumer()
        {
            return this._consumer != null;
        }

    }
}