/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the kinesisvideo-2017-09-30.normal.json service model.
 */

using System;

using Amazon.Runtime;

namespace Amazon.KinesisVideo
{

    /// <summary>
    /// Constants used for properties of type APIName.
    /// </summary>
    public class APIName : ConstantClass
    {

        /// <summary>
        /// Constant GET_CLIP for APIName
        /// </summary>
        public static readonly APIName GET_CLIP = new APIName("GET_CLIP");
        /// <summary>
        /// Constant GET_DASH_STREAMING_SESSION_URL for APIName
        /// </summary>
        public static readonly APIName GET_DASH_STREAMING_SESSION_URL = new APIName("GET_DASH_STREAMING_SESSION_URL");
        /// <summary>
        /// Constant GET_HLS_STREAMING_SESSION_URL for APIName
        /// </summary>
        public static readonly APIName GET_HLS_STREAMING_SESSION_URL = new APIName("GET_HLS_STREAMING_SESSION_URL");
        /// <summary>
        /// Constant GET_MEDIA for APIName
        /// </summary>
        public static readonly APIName GET_MEDIA = new APIName("GET_MEDIA");
        /// <summary>
        /// Constant GET_MEDIA_FOR_FRAGMENT_LIST for APIName
        /// </summary>
        public static readonly APIName GET_MEDIA_FOR_FRAGMENT_LIST = new APIName("GET_MEDIA_FOR_FRAGMENT_LIST");
        /// <summary>
        /// Constant LIST_FRAGMENTS for APIName
        /// </summary>
        public static readonly APIName LIST_FRAGMENTS = new APIName("LIST_FRAGMENTS");
        /// <summary>
        /// Constant PUT_MEDIA for APIName
        /// </summary>
        public static readonly APIName PUT_MEDIA = new APIName("PUT_MEDIA");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public APIName(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static APIName FindValue(string value)
        {
            return FindValue<APIName>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator APIName(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type ChannelProtocol.
    /// </summary>
    public class ChannelProtocol : ConstantClass
    {

        /// <summary>
        /// Constant HTTPS for ChannelProtocol
        /// </summary>
        public static readonly ChannelProtocol HTTPS = new ChannelProtocol("HTTPS");
        /// <summary>
        /// Constant WSS for ChannelProtocol
        /// </summary>
        public static readonly ChannelProtocol WSS = new ChannelProtocol("WSS");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public ChannelProtocol(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static ChannelProtocol FindValue(string value)
        {
            return FindValue<ChannelProtocol>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator ChannelProtocol(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type ChannelRole.
    /// </summary>
    public class ChannelRole : ConstantClass
    {

        /// <summary>
        /// Constant MASTER for ChannelRole
        /// </summary>
        public static readonly ChannelRole MASTER = new ChannelRole("MASTER");
        /// <summary>
        /// Constant VIEWER for ChannelRole
        /// </summary>
        public static readonly ChannelRole VIEWER = new ChannelRole("VIEWER");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public ChannelRole(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static ChannelRole FindValue(string value)
        {
            return FindValue<ChannelRole>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator ChannelRole(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type ChannelType.
    /// </summary>
    public class ChannelType : ConstantClass
    {

        /// <summary>
        /// Constant SINGLE_MASTER for ChannelType
        /// </summary>
        public static readonly ChannelType SINGLE_MASTER = new ChannelType("SINGLE_MASTER");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public ChannelType(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static ChannelType FindValue(string value)
        {
            return FindValue<ChannelType>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator ChannelType(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type ComparisonOperator.
    /// </summary>
    public class ComparisonOperator : ConstantClass
    {

        /// <summary>
        /// Constant BEGINS_WITH for ComparisonOperator
        /// </summary>
        public static readonly ComparisonOperator BEGINS_WITH = new ComparisonOperator("BEGINS_WITH");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public ComparisonOperator(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static ComparisonOperator FindValue(string value)
        {
            return FindValue<ComparisonOperator>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator ComparisonOperator(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type Status.
    /// </summary>
    public class Status : ConstantClass
    {

        /// <summary>
        /// Constant ACTIVE for Status
        /// </summary>
        public static readonly Status ACTIVE = new Status("ACTIVE");
        /// <summary>
        /// Constant CREATING for Status
        /// </summary>
        public static readonly Status CREATING = new Status("CREATING");
        /// <summary>
        /// Constant DELETING for Status
        /// </summary>
        public static readonly Status DELETING = new Status("DELETING");
        /// <summary>
        /// Constant UPDATING for Status
        /// </summary>
        public static readonly Status UPDATING = new Status("UPDATING");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public Status(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static Status FindValue(string value)
        {
            return FindValue<Status>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator Status(string value)
        {
            return FindValue(value);
        }
    }


    /// <summary>
    /// Constants used for properties of type UpdateDataRetentionOperation.
    /// </summary>
    public class UpdateDataRetentionOperation : ConstantClass
    {

        /// <summary>
        /// Constant DECREASE_DATA_RETENTION for UpdateDataRetentionOperation
        /// </summary>
        public static readonly UpdateDataRetentionOperation DECREASE_DATA_RETENTION = new UpdateDataRetentionOperation("DECREASE_DATA_RETENTION");
        /// <summary>
        /// Constant INCREASE_DATA_RETENTION for UpdateDataRetentionOperation
        /// </summary>
        public static readonly UpdateDataRetentionOperation INCREASE_DATA_RETENTION = new UpdateDataRetentionOperation("INCREASE_DATA_RETENTION");

        /// <summary>
        /// This constant constructor does not need to be called if the constant
        /// you are attempting to use is already defined as a static instance of 
        /// this class.
        /// This constructor should be used to construct constants that are not
        /// defined as statics, for instance if attempting to use a feature that is
        /// newer than the current version of the SDK.
        /// </summary>
        public UpdateDataRetentionOperation(string value)
            : base(value)
        {
        }

        /// <summary>
        /// Finds the constant for the unique value.
        /// </summary>
        /// <param name="value">The unique value for the constant</param>
        /// <returns>The constant for the unique value</returns>
        public static UpdateDataRetentionOperation FindValue(string value)
        {
            return FindValue<UpdateDataRetentionOperation>(value);
        }

        /// <summary>
        /// Utility method to convert strings to the constant class.
        /// </summary>
        /// <param name="value">The string value to convert to the constant class.</param>
        /// <returns></returns>
        public static implicit operator UpdateDataRetentionOperation(string value)
        {
            return FindValue(value);
        }
    }

}