/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the lex-models-2017-04-19.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.LexModelBuildingService.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.LexModelBuildingService.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// StartMigration Request Marshaller
    /// </summary>       
    public class StartMigrationRequestMarshaller : IMarshaller<IRequest, StartMigrationRequest> , IMarshaller<IRequest,AmazonWebServiceRequest>
    {
        /// <summary>
        /// Marshaller the request object to the HTTP request.
        /// </summary>  
        /// <param name="input"></param>
        /// <returns></returns>
        public IRequest Marshall(AmazonWebServiceRequest input)
        {
            return this.Marshall((StartMigrationRequest)input);
        }

        /// <summary>
        /// Marshaller the request object to the HTTP request.
        /// </summary>  
        /// <param name="publicRequest"></param>
        /// <returns></returns>
        public IRequest Marshall(StartMigrationRequest publicRequest)
        {
            IRequest request = new DefaultRequest(publicRequest, "Amazon.LexModelBuildingService");
            request.Headers["Content-Type"] = "application/json";
            request.Headers[Amazon.Util.HeaderKeys.XAmzApiVersion] = "2017-04-19";            
            request.HttpMethod = "POST";

            request.ResourcePath = "/migrations";
            using (StringWriter stringWriter = new StringWriter(CultureInfo.InvariantCulture))
            {
                JsonWriter writer = new JsonWriter(stringWriter);
                writer.WriteObjectStart();
                var context = new JsonMarshallerContext(request, writer);
                if(publicRequest.IsSetMigrationStrategy())
                {
                    context.Writer.WritePropertyName("migrationStrategy");
                    context.Writer.Write(publicRequest.MigrationStrategy);
                }

                if(publicRequest.IsSetV1BotName())
                {
                    context.Writer.WritePropertyName("v1BotName");
                    context.Writer.Write(publicRequest.V1BotName);
                }

                if(publicRequest.IsSetV1BotVersion())
                {
                    context.Writer.WritePropertyName("v1BotVersion");
                    context.Writer.Write(publicRequest.V1BotVersion);
                }

                if(publicRequest.IsSetV2BotName())
                {
                    context.Writer.WritePropertyName("v2BotName");
                    context.Writer.Write(publicRequest.V2BotName);
                }

                if(publicRequest.IsSetV2BotRole())
                {
                    context.Writer.WritePropertyName("v2BotRole");
                    context.Writer.Write(publicRequest.V2BotRole);
                }

        
                writer.WriteObjectEnd();
                string snippet = stringWriter.ToString();
                request.Content = System.Text.Encoding.UTF8.GetBytes(snippet);
            }


            return request;
        }
        private static StartMigrationRequestMarshaller _instance = new StartMigrationRequestMarshaller();        

        internal static StartMigrationRequestMarshaller GetInstance()
        {
            return _instance;
        }

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static StartMigrationRequestMarshaller Instance
        {
            get
            {
                return _instance;
            }
        }

    }
}