/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the models.lex.v2-2020-08-07.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.LexModelsV2.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.LexModelsV2.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// ExportResourceSpecification Marshaller
    /// </summary>       
    public class ExportResourceSpecificationMarshaller : IRequestMarshaller<ExportResourceSpecification, JsonMarshallerContext> 
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="requestObject"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public void Marshall(ExportResourceSpecification requestObject, JsonMarshallerContext context)
        {
            if(requestObject.IsSetBotExportSpecification())
            {
                context.Writer.WritePropertyName("botExportSpecification");
                context.Writer.WriteObjectStart();

                var marshaller = BotExportSpecificationMarshaller.Instance;
                marshaller.Marshall(requestObject.BotExportSpecification, context);

                context.Writer.WriteObjectEnd();
            }

            if(requestObject.IsSetBotLocaleExportSpecification())
            {
                context.Writer.WritePropertyName("botLocaleExportSpecification");
                context.Writer.WriteObjectStart();

                var marshaller = BotLocaleExportSpecificationMarshaller.Instance;
                marshaller.Marshall(requestObject.BotLocaleExportSpecification, context);

                context.Writer.WriteObjectEnd();
            }

        }

        /// <summary>
        /// Singleton Marshaller.
        /// </summary>  
        public readonly static ExportResourceSpecificationMarshaller Instance = new ExportResourceSpecificationMarshaller();

    }
}