/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the models.lex.v2-2020-08-07.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text;
using System.Xml.Serialization;

using Amazon.LexModelsV2.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.LexModelsV2.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// ImageResponseCard Marshaller
    /// </summary>       
    public class ImageResponseCardMarshaller : IRequestMarshaller<ImageResponseCard, JsonMarshallerContext> 
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="requestObject"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public void Marshall(ImageResponseCard requestObject, JsonMarshallerContext context)
        {
            if(requestObject.IsSetButtons())
            {
                context.Writer.WritePropertyName("buttons");
                context.Writer.WriteArrayStart();
                foreach(var requestObjectButtonsListValue in requestObject.Buttons)
                {
                    context.Writer.WriteObjectStart();

                    var marshaller = ButtonMarshaller.Instance;
                    marshaller.Marshall(requestObjectButtonsListValue, context);

                    context.Writer.WriteObjectEnd();
                }
                context.Writer.WriteArrayEnd();
            }

            if(requestObject.IsSetImageUrl())
            {
                context.Writer.WritePropertyName("imageUrl");
                context.Writer.Write(requestObject.ImageUrl);
            }

            if(requestObject.IsSetSubtitle())
            {
                context.Writer.WritePropertyName("subtitle");
                context.Writer.Write(requestObject.Subtitle);
            }

            if(requestObject.IsSetTitle())
            {
                context.Writer.WritePropertyName("title");
                context.Writer.Write(requestObject.Title);
            }

        }

        /// <summary>
        /// Singleton Marshaller.
        /// </summary>  
        public readonly static ImageResponseCardMarshaller Instance = new ImageResponseCardMarshaller();

    }
}