/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the mq-2017-11-27.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.MQ.Model
{
    /// <summary>
    /// This is the response object from the DescribeBrokerEngineTypes operation.
    /// </summary>
    public partial class DescribeBrokerEngineTypesResponse : AmazonWebServiceResponse
    {
        private List<BrokerEngineType> _brokerEngineTypes = new List<BrokerEngineType>();
        private int? _maxResults;
        private string _nextToken;

        /// <summary>
        /// Gets and sets the property BrokerEngineTypes. 
        /// <para>
        /// List of available engine types and versions.
        /// </para>
        /// </summary>
        public List<BrokerEngineType> BrokerEngineTypes
        {
            get { return this._brokerEngineTypes; }
            set { this._brokerEngineTypes = value; }
        }

        // Check to see if BrokerEngineTypes property is set
        internal bool IsSetBrokerEngineTypes()
        {
            return this._brokerEngineTypes != null && this._brokerEngineTypes.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property MaxResults. 
        /// <para>
        /// Required. The maximum number of engine types that can be returned per page (20 by
        /// default). This value must be an integer from 5 to 100.
        /// </para>
        /// </summary>
        [AWSProperty(Min=5, Max=100)]
        public int MaxResults
        {
            get { return this._maxResults.GetValueOrDefault(); }
            set { this._maxResults = value; }
        }

        // Check to see if MaxResults property is set
        internal bool IsSetMaxResults()
        {
            return this._maxResults.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// The token that specifies the next page of results Amazon MQ should return. To request
        /// the first page, leave nextToken empty.
        /// </para>
        /// </summary>
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

    }
}