/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the macie2-2020-01-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Macie2.Model
{
    /// <summary>
    /// Container for the parameters to the PutClassificationExportConfiguration operation.
    /// Creates or updates the configuration settings for storing data classification results.
    /// </summary>
    public partial class PutClassificationExportConfigurationRequest : AmazonMacie2Request
    {
        private ClassificationExportConfiguration _configuration;

        /// <summary>
        /// Gets and sets the property Configuration. 
        /// <para>
        /// The location to store data classification results in, and the encryption settings
        /// to use when storing results in that location.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public ClassificationExportConfiguration Configuration
        {
            get { return this._configuration; }
            set { this._configuration = value; }
        }

        // Check to see if Configuration property is set
        internal bool IsSetConfiguration()
        {
            return this._configuration != null;
        }

    }
}