/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the mediaconvert-2017-08-29.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.MediaConvert.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.MediaConvert.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for CmafEncryptionSettings Object
    /// </summary>  
    public class CmafEncryptionSettingsUnmarshaller : IUnmarshaller<CmafEncryptionSettings, XmlUnmarshallerContext>, IUnmarshaller<CmafEncryptionSettings, JsonUnmarshallerContext>
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        CmafEncryptionSettings IUnmarshaller<CmafEncryptionSettings, XmlUnmarshallerContext>.Unmarshall(XmlUnmarshallerContext context)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public CmafEncryptionSettings Unmarshall(JsonUnmarshallerContext context)
        {
            context.Read();
            if (context.CurrentTokenType == JsonToken.Null) 
                return null;

            CmafEncryptionSettings unmarshalledObject = new CmafEncryptionSettings();
        
            int targetDepth = context.CurrentDepth;
            while (context.ReadAtDepth(targetDepth))
            {
                if (context.TestExpression("constantInitializationVector", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.ConstantInitializationVector = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("encryptionMethod", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.EncryptionMethod = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("initializationVectorInManifest", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.InitializationVectorInManifest = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("spekeKeyProvider", targetDepth))
                {
                    var unmarshaller = SpekeKeyProviderCmafUnmarshaller.Instance;
                    unmarshalledObject.SpekeKeyProvider = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("staticKeyProvider", targetDepth))
                {
                    var unmarshaller = StaticKeyProviderUnmarshaller.Instance;
                    unmarshalledObject.StaticKeyProvider = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("type", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.Type = unmarshaller.Unmarshall(context);
                    continue;
                }
            }
          
            return unmarshalledObject;
        }


        private static CmafEncryptionSettingsUnmarshaller _instance = new CmafEncryptionSettingsUnmarshaller();        

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static CmafEncryptionSettingsUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}