/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the mediaconvert-2017-08-29.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.MediaConvert.Model
{
    /// <summary>
    /// Settings for SCTE-35 signals from ESAM. Include this in your job settings to put SCTE-35
    /// markers in your HLS and transport stream outputs at the insertion points that you
    /// specify in an ESAM XML document. Provide the document in the setting SCC XML (sccXml).
    /// </summary>
    public partial class M2tsScte35Esam
    {
        private int? _scte35EsamPid;

        /// <summary>
        /// Gets and sets the property Scte35EsamPid. Packet Identifier (PID) of the SCTE-35 stream
        /// in the transport stream generated by ESAM.
        /// </summary>
        [AWSProperty(Min=32, Max=8182)]
        public int Scte35EsamPid
        {
            get { return this._scte35EsamPid.GetValueOrDefault(); }
            set { this._scte35EsamPid = value; }
        }

        // Check to see if Scte35EsamPid property is set
        internal bool IsSetScte35EsamPid()
        {
            return this._scte35EsamPid.HasValue; 
        }

    }
}