/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the pinpoint-2016-12-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Pinpoint.Model
{
    /// <summary>
    /// Provides information about all the versions of a specific message template.
    /// </summary>
    public partial class TemplateVersionsResponse
    {
        private List<TemplateVersionResponse> _item = new List<TemplateVersionResponse>();
        private string _message;
        private string _nextToken;
        private string _requestID;

        /// <summary>
        /// Gets and sets the property Item. 
        /// <para>
        /// An array of responses, one for each version of the message template.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public List<TemplateVersionResponse> Item
        {
            get { return this._item; }
            set { this._item = value; }
        }

        // Check to see if Item property is set
        internal bool IsSetItem()
        {
            return this._item != null && this._item.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property Message. 
        /// <para>
        /// The message that's returned from the API for the request to retrieve information about
        /// all the versions of the message template.
        /// </para>
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }

        // Check to see if Message property is set
        internal bool IsSetMessage()
        {
            return this._message != null;
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// The string to use in a subsequent request to get the next page of results in a paginated
        /// response. This value is null if there are no additional pages.
        /// </para>
        /// </summary>
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

        /// <summary>
        /// Gets and sets the property RequestID. 
        /// <para>
        /// The unique identifier for the request to retrieve information about all the versions
        /// of the message template.
        /// </para>
        /// </summary>
        public string RequestID
        {
            get { return this._requestID; }
            set { this._requestID = value; }
        }

        // Check to see if RequestID property is set
        internal bool IsSetRequestID()
        {
            return this._requestID != null;
        }

    }
}