/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the quicksight-2018-04-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.QuickSight.Model
{
    /// <summary>
    /// Twitter parameters.
    /// </summary>
    public partial class TwitterParameters
    {
        private int? _maxRows;
        private string _query;

        /// <summary>
        /// Gets and sets the property MaxRows. 
        /// <para>
        /// Maximum number of rows to query Twitter.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true, Min=1)]
        public int MaxRows
        {
            get { return this._maxRows.GetValueOrDefault(); }
            set { this._maxRows = value; }
        }

        // Check to see if MaxRows property is set
        internal bool IsSetMaxRows()
        {
            return this._maxRows.HasValue; 
        }

        /// <summary>
        /// Gets and sets the property Query. 
        /// <para>
        /// Twitter query string.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true, Min=1, Max=256)]
        public string Query
        {
            get { return this._query; }
            set { this._query = value; }
        }

        // Check to see if Query property is set
        internal bool IsSetQuery()
        {
            return this._query != null;
        }

    }
}