/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the redshift-2012-12-01.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Redshift.Model
{
    /// <summary>
    /// This is the response object from the DescribeClusterDbRevisions operation.
    /// </summary>
    public partial class DescribeClusterDbRevisionsResponse : AmazonWebServiceResponse
    {
        private List<ClusterDbRevision> _clusterDbRevisions = new List<ClusterDbRevision>();
        private string _marker;

        /// <summary>
        /// Gets and sets the property ClusterDbRevisions. 
        /// <para>
        /// A list of revisions.
        /// </para>
        /// </summary>
        public List<ClusterDbRevision> ClusterDbRevisions
        {
            get { return this._clusterDbRevisions; }
            set { this._clusterDbRevisions = value; }
        }

        // Check to see if ClusterDbRevisions property is set
        internal bool IsSetClusterDbRevisions()
        {
            return this._clusterDbRevisions != null && this._clusterDbRevisions.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property Marker. 
        /// <para>
        /// A string representing the starting point for the next set of revisions. If a value
        /// is returned in a response, you can retrieve the next set of revisions by providing
        /// the value in the <code>marker</code> parameter and retrying the command. If the <code>marker</code>
        /// field is empty, all revisions have already been returned.
        /// </para>
        /// </summary>
        [AWSProperty(Max=2147483647)]
        public string Marker
        {
            get { return this._marker; }
            set { this._marker = value; }
        }

        // Check to see if Marker property is set
        internal bool IsSetMarker()
        {
            return this._marker != null;
        }

    }
}