/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the rekognition-2016-06-27.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Rekognition.Model
{
    /// <summary>
    /// An object that recognizes faces in a streaming video. An Amazon Rekognition stream
    /// processor is created by a call to <a>CreateStreamProcessor</a>. The request parameters
    /// for <code>CreateStreamProcessor</code> describe the Kinesis video stream source for
    /// the streaming video, face recognition parameters, and where to stream the analysis
    /// resullts.
    /// </summary>
    public partial class StreamProcessor
    {
        private string _name;
        private StreamProcessorStatus _status;

        /// <summary>
        /// Gets and sets the property Name. 
        /// <para>
        /// Name of the Amazon Rekognition stream processor. 
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=128)]
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        // Check to see if Name property is set
        internal bool IsSetName()
        {
            return this._name != null;
        }

        /// <summary>
        /// Gets and sets the property Status. 
        /// <para>
        /// Current status of the Amazon Rekognition stream processor.
        /// </para>
        /// </summary>
        public StreamProcessorStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }

        // Check to see if Status property is set
        internal bool IsSetStatus()
        {
            return this._status != null;
        }

    }
}