/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the route53-recovery-control-config-2020-11-02.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.Route53RecoveryControlConfig.Model
{
    /// <summary>
    /// This is the response object from the UpdateControlPanel operation.
    /// </summary>
    public partial class UpdateControlPanelResponse : AmazonWebServiceResponse
    {
        private ControlPanel _controlPanel;

        /// <summary>
        /// Gets and sets the property ControlPanel. 
        /// <para>
        /// The control panel to update.
        /// </para>
        /// </summary>
        public ControlPanel ControlPanel
        {
            get { return this._controlPanel; }
            set { this._controlPanel = value; }
        }

        // Check to see if ControlPanel property is set
        internal bool IsSetControlPanel()
        {
            return this._controlPanel != null;
        }

    }
}