/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ssm-incidents-2018-05-10.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.SSMIncidents.Model
{
    /// <summary>
    /// Details and type of a related item.
    /// </summary>
    public partial class ItemIdentifier
    {
        private ItemType _type;
        private ItemValue _value;

        /// <summary>
        /// Gets and sets the property Type. 
        /// <para>
        /// The type of related item. Incident Manager supports the following types:
        /// </para>
        ///  <ul> <li> 
        /// <para>
        ///  <code>ANALYSIS</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>INCIDENT</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>METRIC</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>PARENT</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>ATTACHMENT</code> 
        /// </para>
        ///  </li> <li> 
        /// <para>
        ///  <code>OTHER</code> 
        /// </para>
        ///  </li> </ul>
        /// </summary>
        [AWSProperty(Required=true)]
        public ItemType Type
        {
            get { return this._type; }
            set { this._type = value; }
        }

        // Check to see if Type property is set
        internal bool IsSetType()
        {
            return this._type != null;
        }

        /// <summary>
        /// Gets and sets the property Value. 
        /// <para>
        /// Details about the related item.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public ItemValue Value
        {
            get { return this._value; }
            set { this._value = value; }
        }

        // Check to see if Value property is set
        internal bool IsSetValue()
        {
            return this._value != null;
        }

    }
}