/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the servicecatalog-2015-12-10.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.ServiceCatalog.Model
{
    /// <summary>
    /// Details of an execution parameter value that is passed to a self-service action when
    /// executed on a provisioned product.
    /// </summary>
    public partial class ExecutionParameter
    {
        private List<string> _defaultValues = new List<string>();
        private string _name;
        private string _type;

        /// <summary>
        /// Gets and sets the property DefaultValues. 
        /// <para>
        /// The default values for the execution parameter.
        /// </para>
        /// </summary>
        [AWSProperty(Min=0, Max=25)]
        public List<string> DefaultValues
        {
            get { return this._defaultValues; }
            set { this._defaultValues = value; }
        }

        // Check to see if DefaultValues property is set
        internal bool IsSetDefaultValues()
        {
            return this._defaultValues != null && this._defaultValues.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property Name. 
        /// <para>
        /// The name of the execution parameter.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=50)]
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        // Check to see if Name property is set
        internal bool IsSetName()
        {
            return this._name != null;
        }

        /// <summary>
        /// Gets and sets the property Type. 
        /// <para>
        /// The execution parameter type.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=1024)]
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }

        // Check to see if Type property is set
        internal bool IsSetType()
        {
            return this._type != null;
        }

    }
}