/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the sns-2010-03-31.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.SimpleNotificationService.Model
{
    /// <summary>
    /// Container for the parameters to the CheckIfPhoneNumberIsOptedOut operation.
    /// Accepts a phone number and indicates whether the phone holder has opted out of receiving
    /// SMS messages from your account. You cannot send SMS messages to a number that is opted
    /// out.
    /// 
    ///  
    /// <para>
    /// To resume sending messages, you can opt in the number by using the <code>OptInPhoneNumber</code>
    /// action.
    /// </para>
    /// </summary>
    public partial class CheckIfPhoneNumberIsOptedOutRequest : AmazonSimpleNotificationServiceRequest
    {
        private string _phoneNumber;

        /// <summary>
        /// Gets and sets the property PhoneNumber. 
        /// <para>
        /// The phone number for which you want to check the opt out status.
        /// </para>
        /// </summary>
        [AWSProperty(Required=true)]
        public string PhoneNumber
        {
            get { return this._phoneNumber; }
            set { this._phoneNumber = value; }
        }

        // Check to see if PhoneNumber property is set
        internal bool IsSetPhoneNumber()
        {
            return this._phoneNumber != null;
        }

    }
}