/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ssm-2014-11-06.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.SimpleSystemsManagement.Model
{
    /// <summary>
    /// This is the response object from the DescribePatchBaselines operation.
    /// </summary>
    public partial class DescribePatchBaselinesResponse : AmazonWebServiceResponse
    {
        private List<PatchBaselineIdentity> _baselineIdentities = new List<PatchBaselineIdentity>();
        private string _nextToken;

        /// <summary>
        /// Gets and sets the property BaselineIdentities. 
        /// <para>
        /// An array of <code>PatchBaselineIdentity</code> elements.
        /// </para>
        /// </summary>
        public List<PatchBaselineIdentity> BaselineIdentities
        {
            get { return this._baselineIdentities; }
            set { this._baselineIdentities = value; }
        }

        // Check to see if BaselineIdentities property is set
        internal bool IsSetBaselineIdentities()
        {
            return this._baselineIdentities != null && this._baselineIdentities.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property NextToken. 
        /// <para>
        /// The token to use when requesting the next set of items. If there are no additional
        /// items to return, the string is empty.
        /// </para>
        /// </summary>
        public string NextToken
        {
            get { return this._nextToken; }
            set { this._nextToken = value; }
        }

        // Check to see if NextToken property is set
        internal bool IsSetNextToken()
        {
            return this._nextToken != null;
        }

    }
}