/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ssm-2014-11-06.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.SimpleSystemsManagement.Model
{
    /// <summary>
    /// Information about comments added to a document review request.
    /// </summary>
    public partial class DocumentReviewCommentSource
    {
        private string _content;
        private DocumentReviewCommentType _type;

        /// <summary>
        /// Gets and sets the property Content. 
        /// <para>
        /// The content of a comment entered by a user who requests a review of a new document
        /// version, or who reviews the new version.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=1024)]
        public string Content
        {
            get { return this._content; }
            set { this._content = value; }
        }

        // Check to see if Content property is set
        internal bool IsSetContent()
        {
            return this._content != null;
        }

        /// <summary>
        /// Gets and sets the property Type. 
        /// <para>
        /// The type of information added to a review request. Currently, only the value <code>Comment</code>
        /// is supported.
        /// </para>
        /// </summary>
        public DocumentReviewCommentType Type
        {
            get { return this._type; }
            set { this._type = value; }
        }

        // Check to see if Type property is set
        internal bool IsSetType()
        {
            return this._type != null;
        }

    }
}