/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the ssm-2014-11-06.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;
using System.Net;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.SimpleSystemsManagement.Model
{
    /// <summary>
    /// Filter used in the request. Supported filter keys depend on the API operation that
    /// includes the filter. API operations that use <code>MaintenanceWindowFilter&gt;</code>
    /// include the following:
    /// 
    ///  <ul> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindowExecutions</a> 
    /// </para>
    ///  </li> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindowExecutionTaskInvocations</a> 
    /// </para>
    ///  </li> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindowExecutionTasks</a> 
    /// </para>
    ///  </li> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindows</a> 
    /// </para>
    ///  </li> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindowTargets</a> 
    /// </para>
    ///  </li> <li> 
    /// <para>
    ///  <a>DescribeMaintenanceWindowTasks</a> 
    /// </para>
    ///  </li> </ul>
    /// </summary>
    public partial class MaintenanceWindowFilter
    {
        private string _key;
        private List<string> _values = new List<string>();

        /// <summary>
        /// Gets and sets the property Key. 
        /// <para>
        /// The name of the filter.
        /// </para>
        /// </summary>
        [AWSProperty(Min=1, Max=128)]
        public string Key
        {
            get { return this._key; }
            set { this._key = value; }
        }

        // Check to see if Key property is set
        internal bool IsSetKey()
        {
            return this._key != null;
        }

        /// <summary>
        /// Gets and sets the property Values. 
        /// <para>
        /// The filter values.
        /// </para>
        /// </summary>
        public List<string> Values
        {
            get { return this._values; }
            set { this._values = value; }
        }

        // Check to see if Values property is set
        internal bool IsSetValues()
        {
            return this._values != null && this._values.Count > 0; 
        }

    }
}